## openimageio 1.3.14

=== CMakeLists.txt ===
project (OpenImageIO)

# Release version of the library
set (OIIO_VERSION_MAJOR 1)
set (OIIO_VERSION_MINOR 3)
set (OIIO_VERSION_PATCH 14)
set (OIIO_VERSION_RELEASE_TYPE "")   # "dev", "betaX", "RCY", ""

cmake_minimum_required (VERSION 2.6)
if (NOT CMAKE_VERSION VERSION_LESS 2.8.4)
    cmake_policy (SET CMP0017 NEW)
endif ()
message (STATUS "Project source dir = ${PROJECT_SOURCE_DIR}")
message (STATUS "Project build dir = ${CMAKE_BINARY_DIR}")

if ("${PROJECT_SOURCE_DIR}" STREQUAL "${CMAKE_BINARY_DIR}")
    message (FATAL_ERROR "Not allowed to run in-source build!")
endif ()

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE "Release")
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    set (DEBUGMODE ON)
endif ()
if (CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
    # cmake bug workaround -- on some platforms, cmake doesn't set
    # NDEBUG for RelWithDebInfo mode
    add_definitions ("-DNDEBUG")
endif ()

option (CMAKE_USE_FOLDERS "Use the FOLDER target property to organize targets into folders." ON)
mark_as_advanced (CMAKE_USE_FOLDERS)
if (CMAKE_USE_FOLDERS)
    set_property (GLOBAL PROPERTY USE_FOLDERS ON)
endif ()

# Figure out which compiler we're using
if (CMAKE_COMPILER_IS_GNUCC)
    execute_process (COMMAND ${CMAKE_C_COMPILER} -dumpversion
                     OUTPUT_VARIABLE GCC_VERSION
                     OUTPUT_STRIP_TRAILING_WHITESPACE)
    message (STATUS "Using gcc ${GCC_VERSION} as the compiler")
endif ()
message (STATUS "CMAKE_CXX_COMPILER_ID is ${CMAKE_CXX_COMPILER_ID}")
if ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    set (CMAKE_COMPILER_IS_CLANG 1)
    message (STATUS "Using clang as the compiler")
endif ()

## turn on more detailed warnings and consider warnings as errors
set (STOP_ON_WARNING ON CACHE BOOL "Stop building if there are any compiler warnings")
if (NOT MSVC)
    add_definitions ("-Wall")
    if (STOP_ON_WARNING)
        add_definitions ("-Werror")
    endif ()
endif ()

if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_GNUCC)
    # CMake doesn't automatically know what do do with
    # include_directories(SYSTEM...) when using clang or gcc.
    set (CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif ()

if (CMAKE_COMPILER_IS_CLANG)
    # Disable some warnings for Clang, for some things that are too awkward
    # to change just for the sake of having no warnings.
    add_definitions ("-Wno-unused-function")
    add_definitions ("-Wno-overloaded-virtual")
    # disable warning about unused command line arguments
    add_definitions ("-Qunused-arguments")
endif ()

if (CMAKE_COMPILER_IS_GNUCC AND (NOT ${GCC_VERSION} VERSION_LESS 4.8))
    # suppress a warning that Boost::Python hits in g++ 4.8
    add_definitions ("-Wno-error=unused-local-typedefs")
endif ()

if (CMAKE_COMPILER_IS_CLANG OR CMAKE_COMPILER_IS_GNUCC)
    if (HIDE_SYMBOLS AND NOT DEBUGMODE)
        # Turn default symbol visibility to hidden
        set (VISIBILITY_COMMAND "-fvisibility=hidden -fvisibility-inlines-hidden")
        add_definitions (${VISIBILITY_COMMAND})
        if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
            # Linux: also hide all the symbols of dependent libraries to
            # prevent clashes if an app using OIIO is linked against
            # other verions of our dependencies.
            set (VISIBILITY_MAP_COMMAND "-Wl,--version-script=${PROJECT_SOURCE_DIR}/src/libOpenImageIO/libOpenImageIO.map")
        endif ()
    endif ()
endif ()


set (VERBOSE OFF CACHE BOOL "Print lots of messages while compiling")
set (EMBEDPLUGINS ON CACHE BOOL "Embed format plugins in libOpenImageIO")
set (OIIO_BUILD_TOOLS ON CACHE BOOL "Build the command-line tools")
set (OIIO_BUILD_TESTS ON CACHE BOOL "Build the unit tests")
set (BUILDSTATIC OFF CACHE BOOL "Build static library instead of shared")
set (LINKSTATIC OFF CACHE BOOL "Link with static external libraries when possible")
set (HIDE_SYMBOLS OFF CACHE BOOL "Hide symbols not in the public API")
set (USE_OPENGL ON CACHE BOOL "Include OpenGL support")
set (USE_QT ON CACHE BOOL "Include Qt support")
set (FORCE_OPENGL_1 OFF CACHE BOOL "Force iv to use OpenGL's fixed pipeline")
set (USE_TBB OFF CACHE BOOL "Use TBB if needed")
set (USE_PYTHON ON CACHE BOOL "Build the Python bindings")
set (USE_FIELD3D ON CACHE BOOL "Use Field3D if found")
set (USE_OPENJPEG ON CACHE BOOL "Use OpenJpeg if found")
set (USE_OCIO ON CACHE BOOL "Use OpenColorIO for color management if found")
set (USE_OPENCV ON CACHE BOOL "Use OpenCV if found")
set (USE_OPENSSL ON CACHE BOOL "Use OpenSSL if found")
set (USE_FREETYPE ON CACHE BOOL "Use Freetype if found")
set (USE_GIF ON CACHE BOOL "Use GIF if found")
set (NOTHREADS OFF CACHE BOOL "Compile with no threads or locking")
set (PYTHON_VERSION 2.6)
set (USE_EXTERNAL_PUGIXML OFF CACHE BOOL
     "Use an externally built shared library version of the pugixml library")
set (PUGIXML_HOME "" CACHE STRING "Hint about where to find external PugiXML library")
set (USE_EXTERNAL_TBB OFF CACHE BOOL
     "Use system TBB library instead of bundled.")

set (SOVERSION ${OIIO_VERSION_MAJOR}.${OIIO_VERSION_MINOR}
     CACHE STRING "Set the SO version in the SO name of the output library")

set (PYLIB_INCLUDE_SONAME OFF CACHE BOOL "If ON, soname/soversion will be set for Python module library")
set (PYLIB_LIB_PREFIX OFF CACHE BOOL "If ON, prefix the Python module with 'lib'")

if (BUILDSTATIC AND ${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    # On Linux, the lack of -fPIC when building static libraries seems
    # incompatible with the dynamic library needed for the Python bindings.
    set (USE_PYTHON OFF)
endif()

if (NOTHREADS)
    message (STATUS "NO THREADS!")
    add_definitions ("-DNOTHREADS=1")
else ()
    if (VERBOSE)
        message (STATUS "Building with thread support")
    endif ()
endif ()

if (USE_TBB)
    add_definitions ("-DUSE_TBB=1")
else ()
    add_definitions ("-DUSE_TBB=0")
    message (STATUS "TBB will not be used")
endif ()

if (EXTRA_CPP_DEFINITIONS)
    add_definitions ("${EXTRA_CPP_DEFINITIONS}")
endif()

set(CMAKE_MODULE_PATH
    "${PROJECT_SOURCE_DIR}/src/cmake/modules"
    "${PROJECT_SOURCE_DIR}/src/cmake")

# Set the default namespace
if(NOT OIIO_NAMESPACE)
  set(OIIO_NAMESPACE OpenImageIO CACHE STRING
      "Specify the master OpenImageIO C++ namespace: Options include OpenImageIO OpenImageIO_<YOURFACILITY> etc."
      FORCE)
endif(NOT OIIO_NAMESPACE)

message(STATUS "Setting Namespace to: ${OIIO_NAMESPACE}")


include (util_macros)
include (oiio_macros)
include (platform)
include (externalpackages)


include_directories(
    "${CMAKE_SOURCE_DIR}/src/include/"
    "${CMAKE_BINARY_DIR}/include/"
)


###########################################################################
# Paths for install tree customization.  Note that relative paths are relative
# to CMAKE_INSTALL_PREFIX.
set (DEFAULT_BIN_INSTALL_DIR   "bin")
set (DEFAULT_LIB_INSTALL_DIR   "lib")
set (DEFAULT_INCLUDE_INSTALL_DIR "include/OpenImageIO")
if (UNIX AND NOT SELF_CONTAINED_INSTALL_TREE)
    # Try to be well-behaved and install into reasonable places according to
    # the "standard" unix directory heirarchy
    # TODO: Figure out how to get the correct python directory
    set (DEFAULT_PYLIB_INSTALL_DIR "lib/python/site-packages")
    set (DEFAULT_DOC_INSTALL_DIR "share/doc/openimageio")
    set (DEFAULT_MAN_INSTALL_DIR "share/man/man1")
else ()
    # Here is the "self-contained install tree" case: the expectation here is
    # that everything OIIO related will go into its own directory, not into
    # some standard system heirarchy.
    set (DEFAULT_PYLIB_INSTALL_DIR "python")
    set (DEFAULT_DOC_INSTALL_DIR "doc")
    set (DEFAULT_MAN_INSTALL_DIR "doc/man")
endif ()
if (EXEC_INSTALL_PREFIX)
    # Tack on an extra prefix to support multi-arch builds.
    set (DEFAULT_BIN_INSTALL_DIR   "${EXEC_INSTALL_PREFIX}/${DEFAULT_BIN_INSTALL_DIR}")
    set (DEFAULT_LIB_INSTALL_DIR   "${EXEC_INSTALL_PREFIX}/${DEFAULT_LIB_INSTALL_DIR}")
    set (DEFAULT_PYLIB_INSTALL_DIR "${EXEC_INSTALL_PREFIX}/${DEFAULT_PYLIB_INSTALL_DIR}")
endif ()
# Set up cmake cache variables corresponding to the defaults deduced above, so
# that the user can override them as desired:
set (BIN_INSTALL_DIR ${DEFAULT_BIN_INSTALL_DIR} CACHE STRING
     "Install location for binaries (relative to CMAKE_INSTALL_PREFIX or absolute)")
set (LIB_INSTALL_DIR ${DEFAULT_LIB_INSTALL_DIR} CACHE STRING
     "Install location for libraries (relative to CMAKE_INSTALL_PREFIX or absolute)")
set (PYLIB_INSTALL_DIR ${DEFAULT_PYLIB_INSTALL_DIR} CACHE STRING
     "Install location for python libraries (relative to CMAKE_INSTALL_PREFIX or absolute)")
set (INCLUDE_INSTALL_DIR ${DEFAULT_INCLUDE_INSTALL_DIR} CACHE STRING
     "Install location of header files (relative to CMAKE_INSTALL_PREFIX or absolute)")
set (DOC_INSTALL_DIR ${DEFAULT_DOC_INSTALL_DIR} CACHE STRING
     "Install location for documentation (relative to CMAKE_INSTALL_PREFIX or absolute)")
if (UNIX)
    set (MAN_INSTALL_DIR ${DEFAULT_MAN_INSTALL_DIR} CACHE STRING
         "Install location for manual pages (relative to CMAKE_INSTALL_PREFIX or absolute)")
endif()

set (INSTALL_DOCS ON CACHE BOOL "Install documentation")


###########################################################################
# Rpath handling.
if (CMAKE_SKIP_RPATH)
    # We need to disallow the user from truly setting CMAKE_SKIP_RPATH, since
    # we want to run the generated executables from the build tree in order to
    # generate the manual page documentation.  However, we make sure the
    # install rpath is unset so that the install tree is still free of rpaths
    # for linux packaging purposes.
    set (CMAKE_SKIP_RPATH FALSE)
    unset (CMAKE_INSTALL_RPATH)
else ()
    set (CMAKE_INSTALL_RPATH "${LIB_INSTALL_DIR}")
    if (NOT IS_ABSOLUTE ${CMAKE_INSTALL_RPATH})
        set (CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${LIB_INSTALL_DIR}")
    endif ()
    set (CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif ()


if (MSVC)
    add_definitions (-D_CRT_SECURE_NO_DEPRECATE)
    add_definitions (-D_CRT_SECURE_NO_WARNINGS)
    add_definitions (-D_CRT_NONSTDC_NO_WARNINGS)
    add_definitions (-D_SCL_SECURE_NO_WARNINGS)
    add_definitions (-DJAS_WIN_MSVC_BUILD)
    if(NOT LINKSTATIC)
        add_definitions (-DBOOST_ALL_DYN_LINK)
        add_definitions (-DOPENEXR_DLL)
    endif ()
    if (BUILDSTATIC)
         add_definitions(-DOIIO_STATIC_BUILD=1)
    endif ()
endif (MSVC)


# We want CTest for testing
# N.B. This needs to be added before any of the subdirectories, or
# their add_test commands will not register.
include (CTest)


# Tell CMake to process the sub-directories
add_subdirectory (src/libOpenImageIO)

if (OIIO_BUILD_TOOLS)
  add_subdirectory (src/iconvert)
  add_subdirectory (src/idiff)
  add_subdirectory (src/igrep)
  add_subdirectory (src/iinfo)
  add_subdirectory (src/maketx)
  add_subdirectory (src/oiiotool)
  add_subdirectory (src/testtex)
  add_subdirectory (src/iv)
endif ()

# Add IO plugin directories
if (NOT EMBEDPLUGINS)
    add_subdirectory (src/bmp.imageio)
    add_subdirectory (src/cineon.imageio)
    add_subdirectory (src/dds.imageio)
    add_subdirectory (src/dpx.imageio)
    add_subdirectory (src/field3d.imageio)
    add_subdirectory (src/fits.imageio)
    add_subdirectory (src/gif.imageio)
    add_subdirectory (src/hdr.imageio)
    add_subdirectory (src/ico.imageio)
    add_subdirectory (src/iff.imageio)
    add_subdirectory (src/jpeg.imageio)
    add_subdirectory (src/jpeg2000.imageio)
    add_subdirectory (src/openexr.imageio)
    add_subdirectory (src/png.imageio)
    add_subdirectory (src/pnm.imageio)
    add_subdirectory (src/psd.imageio)
    add_subdirectory (src/ptex.imageio)
    add_subdirectory (src/rla.imageio)
    add_subdirectory (src/sgi.imageio)
    add_subdirectory (src/socket.imageio)
    add_subdirectory (src/softimage.imageio)
    add_subdirectory (src/targa.imageio)
    add_subdirectory (src/tiff.imageio)
    add_subdirectory (src/webp.imageio)
    add_subdirectory (src/zfile.imageio)
endif ()

=== Makefile ===
#########################################################################
#
# This is the master makefile.
# Here we put all the top-level make targets, platform-independent
# rules, etc.
#
# Run 'make help' to list helpful targets.
#
#########################################################################


.PHONY: all debug profile clean realclean nuke doxygen

working_dir	:= ${shell pwd}
INSTALLDIR       =${working_dir}

# Figure out which architecture we're on
include ${working_dir}/src/make/detectplatform.mk

# Presence of make variables DEBUG and PROFILE cause us to make special
# builds, which we put in their own areas.
ifdef DEBUG
    variant +=.debug
endif
ifdef PROFILE
    variant +=.profile
endif

MY_MAKE_FLAGS ?=
MY_CMAKE_FLAGS ?= -DSELF_CONTAINED_INSTALL_TREE:BOOL=TRUE

# Site-specific build instructions
ifndef OPENIMAGEIO_SITE
    OPENIMAGEIO_SITE := ${shell uname -n}
endif
$(info OPENIMAGEIO_SITE = ${OPENIMAGEIO_SITE})
ifneq (${shell echo ${OPENIMAGEIO_SITE} | grep imageworks},)
include ${working_dir}/site/spi/Makefile-bits
endif

# Set up variables holding the names of platform-dependent directories --
# set these after evaluating site-specific instructions
top_build_dir := build
build_dir     := ${top_build_dir}/${platform}${variant}
top_dist_dir  := dist
dist_dir      := ${top_dist_dir}/${platform}${variant}

$(info dist_dir = ${dist_dir})
$(info INSTALLDIR = ${INSTALLDIR})


VERBOSE := ${SHOWCOMMANDS}
ifneq (${VERBOSE},)
MY_MAKE_FLAGS += VERBOSE=${VERBOSE}
MY_CMAKE_FLAGS += -DVERBOSE:BOOL=1
TEST_FLAGS += -V
endif

ifneq (${EMBEDPLUGINS},)
MY_CMAKE_FLAGS += -DEMBEDPLUGINS:BOOL=${EMBEDPLUGINS}
endif

ifneq (${USE_OPENGL},)
MY_CMAKE_FLAGS += -DUSE_OPENGL:BOOL=${USE_OPENGL}
endif

ifneq (${USE_QT},)
MY_CMAKE_FLAGS += -DUSE_QT:BOOL=${USE_QT}
endif

ifneq (${FORCE_OPENGL_1},)
MY_CMAKE_FLAGS += -DFORCE_OPENGL_1:BOOL=${FORCE_OPENGL_1}
endif

ifneq (${USE_TBB},)
MY_CMAKE_FLAGS += -DUSE_TBB:BOOL=${USE_TBB}
endif

ifneq (${NOTHREADS},)
MY_CMAKE_FLAGS += -DNOTHREADS:BOOL=${NOTHREADS}
endif

ifneq (${NAMESPACE},)
MY_CMAKE_FLAGS += -DOIIO_NAMESPACE:STRING=${NAMESPACE}
endif

ifneq (${HIDE_SYMBOLS},)
MY_CMAKE_FLAGS += -DHIDE_SYMBOLS:BOOL=${HIDE_SYMBOLS}
endif

ifneq (${USE_PYTHON},)
MY_CMAKE_FLAGS += -DUSE_PYTHON:BOOL=${USE_PYTHON}
endif

ifneq (${PYTHON_VERSION},)
MY_CMAKE_FLAGS += -DPYTHON_VERSION:STRING=${PYTHON_VERSION}
endif

ifneq (${USE_FIELD3D},)
MY_CMAKE_FLAGS += -DUSE_FIELD3D:BOOL=${USE_FIELD3D}
endif

ifneq (${FIELD3D_HOME},)
MY_CMAKE_FLAGS += -DFIELD3D_HOME:STRING=${FIELD3D_HOME}
endif

ifneq (${USE_OPENJPEG},)
MY_CMAKE_FLAGS += -DUSE_OPENJPEG:BOOL=${USE_OPENJPEG}
endif

ifneq (${USE_GIF},)
MY_CMAKE_FLAGS += -DUSE_GIF:BOOL=${USE_GIF}
endif

ifneq (${GIF_DIR},)
MY_CMAKE_FLAGS += -DGIF_DIR:STRING=${GIF_DIR}
endif

ifneq (${USE_OCIO},)
MY_CMAKE_FLAGS += -DUSE_OCIO:BOOL=${USE_OCIO}
endif

ifneq (${USE_OPENSSL},)
MY_CMAKE_FLAGS += -DUSE_OPENSSL:BOOL=${USE_OPENSSL}
endif

ifneq (${USE_EXTERNAL_PUGIXML},)
MY_CMAKE_FLAGS += -DUSE_EXTERNAL_PUGIXML:BOOL=${USE_EXTERNAL_PUGIXML} -DPUGIXML_HOME=${PUGIXML_HOME}
endif

ifneq (${ILMBASE_HOME},)
MY_CMAKE_FLAGS += -DILMBASE_HOME:STRING=${ILMBASE_HOME}
endif
ifneq (${OPENEXR_HOME},)
MY_CMAKE_FLAGS += -DOPENEXR_HOME:STRING=${OPENEXR_HOME}
endif

ifneq (${OCIO_HOME},)
MY_CMAKE_FLAGS += -DOCIO_PATH:STRING=${OCIO_HOME}
endif

ifneq (${BOOST_HOME},)
MY_CMAKE_FLAGS += -DBOOST_ROOT:STRING=${BOOST_HOME}
endif

ifneq (${STOP_ON_WARNING},)
MY_CMAKE_FLAGS += -DSTOP_ON_WARNING:BOOL=${STOP_ON_WARNING}
endif

ifneq (${BUILDSTATIC},)
MY_CMAKE_FLAGS += -DBUILDSTATIC:BOOL=${BUILDSTATIC}
endif

ifneq (${LINKSTATIC},)
MY_CMAKE_FLAGS += -DLINKSTATIC:BOOL=${LINKSTATIC}
endif

ifneq (${OIIO_BUILD_TOOLS},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_TOOLS:BOOL=${OIIO_BUILD_TOOLS}
endif

ifneq (${OIIO_BUILD_TESTS},)
MY_CMAKE_FLAGS += -DOIIO_BUILD_TESTS:BOOL=${OIIO_BUILD_TESTS}
endif

ifneq (${SOVERSION},)
MY_CMAKE_FLAGS += -DSOVERSION:STRING=${SOVERSION}
endif

ifneq (${PYLIB_LIB_PREFIX},)
MY_CMAKE_FLAGS += -DPYLIB_LIB_PREFIX:BOOL=${PYLIB_LIB_PREFIX}
endif

ifneq (${PYLIB_INCLUDE_SONAME},)
MY_CMAKE_FLAGS += -DPYLIB_INCLUDE_SONAME:BOOL=${PYLIB_INCLUDE_SONAME}
endif

ifdef DEBUG
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=Debug
endif

ifdef PROFILE
MY_CMAKE_FLAGS += -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo
endif

ifneq (${MYCC},)
MY_CMAKE_FLAGS += -DCMAKE_C_COMPILER:STRING=${MYCC}
endif
ifneq (${MYCXX},)
MY_CMAKE_FLAGS += -DCMAKE_CXX_COMPILER:STRING=${MYCXX}
endif

ifneq (${TEST},)
TEST_FLAGS += -R ${TEST}
endif

#$(info MY_CMAKE_FLAGS = ${MY_CMAKE_FLAGS})
#$(info MY_MAKE_FLAGS = ${MY_MAKE_FLAGS})

#########################################################################




#########################################################################
# Top-level documented targets

all: dist

# 'make debug' is implemented via recursive make setting DEBUG
debug:
	${MAKE} DEBUG=1 --no-print-directory

# 'make profile' is implemented via recursive make setting PROFILE
profile:
	${MAKE} PROFILE=1 --no-print-directory

# 'make cmakesetup' constructs the build directory and runs 'cmake' there,
# generating makefiles to build the project.  For speed, it only does this when
# ${build_dir}/Makefile doesn't already exist, in which case we rely on the
# cmake generated makefiles to regenerate themselves when necessary.
cmakesetup:
	@ (if [ ! -e ${build_dir}/Makefile ] ; then \
		cmake -E make_directory ${build_dir} ; \
		cd ${build_dir} ; \
		cmake -DCMAKE_INSTALL_PREFIX=${INSTALLDIR}/${dist_dir} \
			${MY_CMAKE_FLAGS} -DBOOST_ROOT=${BOOST_HOME} \
			../.. ; \
	 fi)

# 'make cmake' does a basic build (after first setting it up)
cmake: cmakesetup
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} )

# 'make cmakeinstall' builds everthing and installs it in 'dist'.
# Suppress pointless output from docs installation.
cmakeinstall: cmake
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} install | grep -v '^-- \(Installing\|Up-to-date\).*doc/html' )

# 'make dist' is just a synonym for 'make cmakeinstall'
dist : cmakeinstall

# 'make test' does a full build and then runs all tests
test: cmake
	cmake -E cmake_echo_color --switch=$(COLOR) --cyan "Running tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; ctest --force-new-ctest-process ${TEST_FLAGS} -E broken )

# 'make testall' does a full build and then runs all tests (even the ones
# that are expected to fail on some platforms)
testall: cmake
	cmake -E cmake_echo_color --switch=$(COLOR) --cyan "Running all tests ${TEST_FLAGS}..."
	( cd ${build_dir} ; ctest --force-new-ctest-process ${TEST_FLAGS} )

# 'make package' builds everything and then makes an installable package 
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package: cmakeinstall
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package )

# 'make package_source' makes an installable source package 
# (platform dependent -- may be .tar.gz, .sh, .dmg, .rpm, .deb. .exe)
package_source: cmakeinstall
	( cd ${build_dir} ; ${MAKE} ${MY_MAKE_FLAGS} package_source )

#clean: testclean
# 'make clean' clears out the build directory for this platform
clean:
	cmake -E remove_directory ${build_dir}

# 'make realclean' clears out both build and dist directories for this platform
realclean: clean
	cmake -E remove_directory ${dist_dir}

# 'make nuke' blows away the build and dist areas for all platforms
nuke:
	cmake -E remove_directory ${top_build_dir}
	cmake -E remove_directory ${top_dist_dir}

doxygen:
	doxygen src/doc/Doxyfile

#########################################################################



# 'make help' prints important make targets
help:
	@echo "Targets:"
	@echo "  make              Build optimized binaries and libraries in ${dist_dir},"
	@echo "                        temporary build files in ${build_dir}"
	@echo "  make debug        Build unoptimized with symbols in ${dist_dir}.debug,"
	@echo "                        temporary build files in ${build_dir}.debug"
	@echo "  make profile      Build for profiling in ${dist_dir}.profile,"
	@echo "                        temporary build files in ${build_dir}.profile"
	@echo "  make clean        Remove the temporary files in ${build_dir}"
	@echo "  make realclean    Remove both ${build_dir} AND ${dist_dir}"
	@echo "  make nuke         Remove ALL of build and dist (not just ${platform})"
	@echo "  make test         Run tests"
	@echo "  make testall      Run all tests, even broken ones"
	@echo "  make doxygen      Build the Doxygen docs in ${top_build_dir}/doxygen"
	@echo ""
	@echo "Helpful modifiers:"
	@echo "  make VERBOSE=1 ...          Show all compilation commands"
	@echo "  make STOP_ON_WARNING=0      Do not stop building if compiler warns"
	@echo "  make SOVERSION=nn ...       Include the specifed major version number "
	@echo "                                in the shared object metadata"
	@echo "  make NAMESPACE=name         Wrap everything in another namespace"
	@echo "  make HIDE_SYMBOLS=1         Hide symbols not in the public API"
	@echo "  make EMBEDPLUGINS=0 ...     Don't compile the plugins into libOpenImageIO"
	@echo "  make MYCC=xx MYCXX=yy ...   Use custom compilers"
	@echo "  make USE_QT=0 ...           Skip anything that needs Qt"
	@echo "  make USE_OPENGL=0 ...       Skip anything that needs OpenGL"
	@echo "  make FORCE_OPENGL_1=1 ...   Force iv to use OpenGL's fixed pipeline"
	@echo "  make USE_TBB=1 ...          Use TBB for atomics and spin locks"
	@echo "  make USE_PYTHON=0 ...       Don't build the Python binding"
	@echo "  make PYTHON_VERSION=2.6 ... Specify the Python version"
	@echo "  make USE_FIELD3D=0 ...      Don't build the Field3D plugin"
	@echo "  make USE_OPENJPEG=0 ...     Don't build the JPEG-2000 plugin"
	@echo "  make USE_GIF=0 ...          Don't build the GIF plugin"
	@echo "  make USE_OCIO=0 ...         Don't use OpenColorIO even if found"
	@echo "  make USE_OPENSSL=0 ...      Don't use OpenSSL even if found"
	@echo "  make USE_EXTERNAL_PUGIXML=1 Use the system PugiXML, not the one in OIIO"
	@echo "  make FIELD3D_HOME=path ...  Custom Field3D installation"
	@echo "  make GIF_DIR=path ...       Custom GIFLIB installation"
	@echo "  make ILMBASE_HOME=path ...  Custom Ilmbase installation"
	@echo "  make OPENEXR_HOME=path ...  Custom OpenEXR installation"
	@echo "  make OCIO_HOME=path ...     Custom OpenColorIO installation"
	@echo "  make BOOST_HOME=path ...    Custom Boost installation"
	@echo "  make BUILDSTATIC=1 ...      Build static library instead of shared"
	@echo "  make LINKSTATIC=1 ...       Link with static external libraries when possible"
	@echo "  make OIIO_BUILD_TOOLS=0 ... Skip building the command-line tools"
	@echo "  make OIIO_BUILD_TESTS=0 ... Skip building the unit tests"
	@echo ""

=== src/include/CMakeLists.txt ===
set (public_headers argparse.h color.h dassert.h errorhandler.h export.h 
                    filesystem.h filter.h fmath.h hash.h
                    imagebuf.h imagebufalgo.h imagebufalgo_util.h
                    imagecache.h imageio.h
                    optparser.h osdep.h paramlist.h plugin.h
                    refcnt.h string_ref.h string_view.h strutil.h sysutil.h
                    texture.h thread.h timer.h
                    tinyformat.h typedesc.h ustring.h varyingref.h
    )

if (NOT USE_EXTERNAL_PUGIXML)
    list (APPEND public_headers pugixml.hpp pugiconfig.hpp pugixml.cpp)
endif()

message(STATUS "Create version.h from version.h.in")
# Mangle the SOVERSION so that it's a valid C++ identifier for the versioning
# namespace defined in version.h
string (REGEX REPLACE "\\." "_" MANGLED_SOVERSION ${SOVERSION})
set (OIIO_VERSION_NS "v${MANGLED_SOVERSION}")
configure_file(version.h.in "${CMAKE_BINARY_DIR}/include/version.h" @ONLY)
list(APPEND public_headers "${CMAKE_BINARY_DIR}/include/version.h")

install (FILES ${public_headers} DESTINATION ${INCLUDE_INSTALL_DIR}
         COMPONENT developer)

if (USE_TBB AND NOT USE_EXTERNAL_TBB)
    install (DIRECTORY tbb DESTINATION ${INCLUDE_INSTALL_DIR}
             COMPONENT developer)
endif ()

=== debian/changelog ===
openimageio (1.3.14-0irie1~precise1) precise; urgency=medium

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 20 May 2014 14:29:30 +0900

openimageio (1.3.13-0irie1~trusty1) trusty; urgency=medium

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 12 Apr 2014 12:25:04 +0900

openimageio (1.3.12-0irie1~saucy1) saucy; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 08 Feb 2014 15:12:28 +0900

openimageio (1.3.11-0irie1~saucy1) saucy; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 18 Jan 2014 19:01:57 +0900

openimageio (1.3.9-0irie1~saucy1) saucy; urgency=low

  * New upstream release
  * Move to RB-1.3 branch:
    - Rename shared library package from libopenimageio1.2 to libopenimageio1.3
  * debian/misc/oiiotool.1:
    - Add new options: --dumpdata, --flatten, --ociodisplay
    - Update descriptions: --frames, --framepadding

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 31 Dec 2013 21:57:22 +0900

openimageio (1.2.3-0irie1~saucy1) saucy; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Wed, 06 Nov 2013 20:11:42 +0900

openimageio (1.2.2-0irie1~raring1) raring; urgency=low

  * New upstream release
  * debian/misc/oiiotool.1:
    - Add new option: --siappend

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 06 Oct 2013 19:45:38 +0900

openimageio (1.2.1-0irie1~raring1) raring; urgency=low

  * New upstream release
  * Move to RB-1.2 branch:
    - Rename shared library from libopenimageio1.1 to libopenimageio1.2
  * debian/misc/oiiotool.1:
    - Add new options: --runstats, --colorcount, --rangecheck, --autotrim,
            --kernel, --mul, --cadd, --chsum, --paste, --mosaic, --transpose,
            --cshift, --resample, --convolve, --blur, --unsharp, --fft, --ifft,
            --ociolook, --unpremult, --premult
    - Update descriptions: -d, --cmul
  * debian/misc/maketx.1:
    - Add new options: --old, --chnames, --lightprobe
    - Update descriptions: --filter, --Mscreen
    - Delete options: --fov, --hash, --envcube

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 11 Aug 2013 02:16:59 +0900

openimageio (1.1.13-0irie1~raring1) raring; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 30 Jun 2013 14:39:34 +0900

openimageio (1.1.11-0irie1~raring1) raring; urgency=low

  * New upstream release
  * Remove patch 010_include_tbb_assert_impl:
    - Fixed upstream c56ffac319 (oiio issue #555)

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sun, 09 Jun 2013 18:29:41 +0900

openimageio (1.1.10-0irie1~raring1) raring; urgency=low

  * New upstream release
  * debian/copyright:
    - Fix lintian error copyright-should-refer-to-common-license-file-for-gpl
  * debian/misc/oiiotool.1:
    - Add new options: --fillholes, --clamp, --rangecompress, --rangeexpand
  * debian/misc/maketx.1:
    - Add new option: --hicomp

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Tue, 23 Apr 2013 13:03:48 +0900

openimageio (1.1.9-0irie1~raring1) raring; urgency=low

  * New upstream release
  * debian/misc/oiiotool.1:
    - Add new options: --frames, --framepadding
    - Update description: --fit
  * debian/control:
    - Build-Depends uses libtiff-dev instead of libtiff4-dev

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Mon, 08 Apr 2013 17:50:59 +0900

openimageio (1.1.8-0irie1~raring1) raring; urgency=low

  * New upstream release
  * debian/misc/oiiotool.1:
    - Add new options: --chnames, --chappend

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 29 Mar 2013 14:32:59 +0900

openimageio (1.1.7-0irie1~quantal1) quantal; urgency=low

  * New upstream release

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 23 Feb 2013 18:08:51 +0900

openimageio (1.1.6-0irie1~quantal1) quantal; urgency=low

  * New upstream release
  * debian/misc/oiiotool.1:
    - Add new options: --cmul, --fit, --swap
    - Update descriptions:
        --create, --pattern, --capture, --zover, --histogram, --resize, --fill

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 16 Feb 2013 03:45:08 +0900

openimageio (1.1.5-0irie2~quantal1) quantal; urgency=low

  * Disable system wide libtbb again:
    - debian/control: Remove libtbb-dev from Build-Depends
    - debian/rules: Remove CMake option -DUSE_EXTERNAL_TBB:BOOL=ON
  * debian/copyright:
    - Update copyright year
    - Add descriptions of external libraries:
       TBB (GPL-2 with exception), pugixml (Expat)
  * Add patch 010_include_tbb_assert_impl:
    - Fix build failure on 32bit platforms

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Thu, 07 Feb 2013 17:31:45 +0900

openimageio (1.1.5-0irie1~quantal1) quantal; urgency=low

  * New upstream release
  * debian/control:
    - Add libtbb-dev, libwebp-dev, libfreetype6-dev to Build-Depends
  * debian/rules:
    - Add CMake option -DUSE_EXTERNAL_TBB:BOOL=ON to use sysem wide libtbb
  * Remove patch 010_fix_FTBFS_on_i386:
    - Fixed upstream
  * debian/misc/oiiotool.1:
    - Add new options: --metamatch, --no-metamatch, --zover
    - Update descriptions: --create, --pattern, --capture, --histogram

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Sat, 02 Feb 2013 18:58:18 +0900

openimageio (1.1.3-0irie1~quantal1) quantal; urgency=low

  * New upstream release
  * debian/misc/*.1:
    - maketx.1: Add --fullpixels option
    - oiiotool.1: Fix --over option

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Thu, 17 Jan 2013 04:19:29 +0900

openimageio (1.1.2-0irie2~quantal1) quantal; urgency=low

  * Add patch 010_fix_FTBFS_on_i386:
    - Import from Blender's install_deps.sh script

 -- IRIE Shinsuke <irieshinsuke@yahoo.co.jp>  Fri, 14 Dec 2012 20:00:28 +0900

openimageio (1.1.2-0irie1~quantal1) quantal; urgency=low

  * Move to RB-1.1 branch:
    - Rename shared library from libopenimageio1.0 to libopenimageio1.1
  * Refresh a patch 020_multiarch_findlibs
  * debian/docs:
    - Rename README to README.rst


=== debian/control ===
Source: openimageio
Priority: extra
Maintainer: IRIE Shinsuke <irieshinsuke@yahoo.co.jp>
Build-Depends: debhelper (>= 7.0.50~), cmake, libboost-filesystem-dev,
	       libboost-thread-dev, libboost-regex-dev, libboost-system-dev,
	       libopenexr-dev, libpng12-dev, libjpeg-dev, libtiff-dev,
	       libopenjpeg-dev, libglew-dev, libqt4-opengl-dev,
	       libwebp-dev, libfreetype6-dev
Standards-Version: 3.9.2
Section: libs
Homepage: https://sites.google.com/site/openimageio/

Package: libopenimageio1.3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openimageio-doc
Description: Library for reading and writing images - runtime
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains the runtime library for programs that use libOpenImageIO.

Package: libopenimageio-dev
Section: libdevel
Architecture: any
Depends: libopenimageio1.3 (= ${binary:Version}), ${misc:Depends}
Suggests: openimageio-doc
Description: Library for reading and writing images - development
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains the header files for building programs that use
 libOpenImageIO.

Package: openimageio-tools
Section: graphics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: openimageio-doc
Description: Library for reading and writing images - command line tools
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains command line tools, including iv image viewer.

Package: openimageio-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Library for reading and writing images - reference manual
 OpenImageIO is a library for reading and writing images, and a bunch of
 related classes, utilities, and applications. Main features include:
 .
  * Extremely simple but powerful ImageInput and ImageOutput APIs for reading
    and writing 2D images that is format agnostic -- that is, a "client app"
    doesn't need to know the details about any particular image file formats.
    Specific formats are implemented by DLL/DSO plugins.
 .
  * Format plugins for TIFF, JPEG/JFIF, OpenEXR, PNG, HDR/RGBE, Targa,
    JPEG-2000, DPX, Cineon, FITS, BMP, ICO, RMan Zfile, Softimage PIC, DDS,
    SGI, PNM/PPM/PGM/PBM, Field3d, WebP. More coming! The plugins are really
    good at understanding all the strange corners of the image formats, and
    are very careful about preserving image metadata (including Exif, GPS, and
    IPTC data).
  .
  * An ImageCache class that transparently manages a cache so that it can access
    truly vast amounts of image data (thousands of image files totaling hundreds
    of GB) very efficiently using only a tiny amount (tens of megabytes at most)
    of runtime memory. Additionally, a TextureSystem class provides filtered
    MIP-map texture lookups, atop the nice caching behavior of ImageCache.
 .
  * Several image tools based on these classes, including iinfo (print detailed
    info about images), iconvert (convert among formats, data types, or modify
    metadata), idiff (compare images),igrep (search images for matching
    metadata). Because these tools are based on ImageInput/ImageOutput, they
    work with any image formats for which ImageIO plugins are available.
 .
  * A really nice image viewer, iv, also based on OpenImageIO classes (and so
    will work with any formats for which plugins are available).
 .
  * Supported on Linux, OS X, and Windows.
 .
  * All available under the BSD license, so you may modify it and use it in both
    open source or proprietary apps.
 .
 This package contains the reference manual of libOpenImageIO.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

BLDDIR = debian/cmake

%:
	dh $@ -Scmake -B$(BLDDIR) --parallel

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_SKIP_RPATH:BOOL=ON \
		-DBUILD_TESTING:BOOL=OFF \
		-DUSE_FIELD3D:BOOL=OFF \
		-DUSE_OCIO:BOOL=OFF \
		-DUSE_PYTHON:BOOL=OFF

override_dh_installchangelogs:
	dh_installchangelogs CHANGES
